% -----------------------------------------------------------------
% Detecci de cares en les imatges procedents de video o imatge estatica
% Input params:
% vid   identificador de la webcam
% handles del gui on es mostren les imatges
% src operaci que cal realitzar
%
% Output params:
% none
%         
% -----------------------------------------------------------------

function frameDisplay2(obj,event,vid,handles,src)	
    
    p = load('params.mat','Params');
    Params = p.Params;
    
    %% Tractament d'una imatge estàtica (només es detecten cares)
    if strcmp(src,Params.photo) == 1
        
        h = findall(handles.gui_altabdd_axesPreview,'type','image');
        IM = get(h,'CDATA');
                
        cares.imOrg = [];
        cares.rects = [];

        iGray = Utils.doGray(IM);
        [faces, numFaces] = MfaceDetect.doFaceDetect(iGray,Params.scaleFaceMin);
        
        if numFaces > 0
            
            axes(handles.gui_altabdd_axesPreview);
            hold on;
            for h=1:size(faces,1)            
                % Es pinten els rectangles
                r = Utils.makeRect(faces(h,:));            
                plot(r(:, 1), r(:, 2), 'g');                

                cares(h).imOrg = IM;
                cares(h).rects = faces(h,:);           
            end

            save(Params.pathDatabaseInsBdd, 'cares');
            set(handles.gui_altabdd_pButtonSnap, 'enable', 'on');

            hold off;      
        else
            set(handles.gui_altabdd_pButtonSnap, 'enable', 'off');
        end
    %% Tractament del video procedent de la webcam (només es detecten cares)    
    elseif strcmp(src,Params.video) == 1

        trigger(vid);
        IM=getdata(vid,1,'uint8');
	
        imshow(IM,'Parent',handles.gui_altabdd_axesPreview);

        cares.imOrg = [];
        cares.rects = [];

        iGray = Utils.doGray(IM);
        [faces, numFaces] = MfaceDetect.doFaceDetect(iGray,Params.scaleFaceMin);

        if numFaces > 0
            axes(handles.gui_altabdd_axesPreview);
            hold on;
            for h=1:size(faces,1)            
                % Es pinten els rectangles
                r = Utils.makeRect(faces(h,:));            
                plot(r(:, 1), r(:, 2), 'g');                

                cares(h).imOrg = IM;
                cares(h).rects = faces(h,:);           
            end

            save(Params.pathDatabaseInsBdd, 'cares');
            set(handles.gui_altabdd_pButtonSnap, 'enable', 'on');

            hold off;            
        end
    end

end

