function varargout = gui_eigenfaces(varargin)
% GUI_EIGENFACES M-file for gui_eigenfaces.fig
%      GUI_EIGENFACES, by itself, creates a new GUI_EIGENFACES or raises the existing
%      singleton*.
%
%      H = GUI_EIGENFACES returns the handle to a new GUI_EIGENFACES or the handle to
%      the existing singleton*.
%
%      GUI_EIGENFACES('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_EIGENFACES.M with the given input arguments.
%
%      GUI_EIGENFACES('Property','Value',...) creates a new GUI_EIGENFACES or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_eigenfaces_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_eigenfaces_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_eigenfaces

% Last Modified by GUIDE v2.5 05-Jan-2013 00:08:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_eigenfaces_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_eigenfaces_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_eigenfaces is made visible.
function gui_eigenfaces_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_eigenfaces (see VARARGIN)

% Choose default command line output for gui_eigenfaces
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

p = load('params.mat','Params');
Params = p.Params;

% Carreguem una imatge per defecte
Utils.doImage(handles.gui_eigenfaces_axesCara, Params.defaultImg);
Utils.doImage(handles.gui_eigenfaces_axesEigen, Params.defaultImg);

desactivaHandles(handles.gui_eigenfaces_pButtonEigen);
desactivaHandles(handles.gui_eigenfaces_pButtonLoad);
% UIWAIT makes gui_eigenfaces wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_eigenfaces_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in gui_eigenfaces_pButtonLoad.
function gui_eigenfaces_pButtonLoad_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_pButtonLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global rutaImatge;

p = load('params.mat','Params');
Params = p.Params;

% Quadre de dialeg per cercar una imatge
[file, path, index] = uigetfile(Params.filtreImg, 'Carrega una imatge');

% Es comprova que s'hagi seleccionat un fitxer
if ~isequal(file, 0)    
    rutaImatge = strcat(path, '\', file);
    Utils.doImage(handles.gui_eigenfaces_axesCara, rutaImatge); 
    activaHandles(handles.gui_eigenfaces_pButtonEigen);
else
    errordlg('No s''ha seleccionat cap fitxer','Error','modal');
end


% --- Executes on button press in gui_eigenfaces_pButtonEigen.
function gui_eigenfaces_pButtonEigen_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_pButtonEigen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    
    global rutaImatge;
    
    p = load('params.mat','Params');
    Params = p.Params;
    
    if isempty(get(handles.gui_eigenfaces_iTxtNumEigenvect,'string'))
        errordlg('Cal introduir el nombre de eigenvectors', 'Error', 'modal');        
    elseif isempty(get(handles.gui_eigenfaces_iTxtMaxDist,'string'))
        errordlg('Cal introduir una distancia entre imatges mxima', 'Error', 'modal');        
    else        
        Utils.doImage(handles.gui_eigenfaces_axesEigen, Params.imgProc);
        pause(3);
        try
            nEigenVects = str2double(get(handles.gui_eigenfaces_iTxtNumEigenvect,'string'));
            maxDist = str2double(get(handles.gui_eigenfaces_iTxtMaxDist,'string'));
            
            desactivaHandles([handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonLoad
                                    handles.gui_eigenfaces_pButtonEigen]);    

            [w, noms] = MfaceRecognition.loadDatabasePca(false,NaN,Params.pathDatabase, Params.pathDatabaseMatFilePca);
            iR = Utils.doGray(imread(rutaImatge));
            [idx, dist, imatge, errorMida] = MfaceRecognition.pcaFaceRecognition(iR,nEigenVects,w);

            activaHandles([handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonLoad
                                    handles.gui_eigenfaces_pButtonEigen]);
                        
            if errorMida
                errordlg('Error mida imatge de test', 'Error', 'modal');
                Utils.doImage(handles.gui_eigenfaces_axesCara, Params.defaultImg);
                Utils.doImage(handles.gui_eigenfaces_axesEigen, Params.defaultImg);
            else
                if dist <= maxDist
                    imshow(imatge,'Parent',handles.gui_eigenfaces_axesEigen);
                    
                    set(handles.gui_eigenfaces_iTxtDist,'string',num2str(dist));
                    set(handles.gui_eigenfaces_iTxtPersona,'string',noms(idx));
                else
                    Utils.doImage(handles.gui_eigenfaces_axesEigen, Params.imgNotRecognized);
                    set(handles.gui_eigenfaces_iTxtDist,'string',num2str(dist));
                end
            end
        catch err
             errordlg(getReport(err), 'Error', 'modal');
             activaHandles([handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonLoad
                                    handles.gui_eigenfaces_pButtonEigen]);
        end
    end
    

function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_eigenfaces_iTxtMaxDist as text
%        str2double(get(hObject,'String')) returns contents of gui_eigenfaces_iTxtMaxDist as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_eigenfaces_iTxtPersona_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtPersona (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_eigenfaces_iTxtPersona as text
%        str2double(get(hObject,'String')) returns contents of gui_eigenfaces_iTxtPersona as a double


% --- Executes during object creation, after setting all properties.
function gui_eigenfaces_iTxtPersona_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtPersona (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function gui_eigenfaces_iTxtDist_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_eigenfaces_iTxtMaxDist as text
%        str2double(get(hObject,'String')) returns contents of gui_eigenfaces_iTxtMaxDist as a double


% --- Executes during object creation, after setting all properties.
function gui_eigenfaces_iTxtDist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function gui_eigenfaces_iTxtMaxDist_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_eigenfaces_iTxtMaxDist as text
%        str2double(get(hObject,'String')) returns contents of gui_eigenfaces_iTxtMaxDist as a double


% --- Executes during object creation, after setting all properties.
function gui_eigenfaces_iTxtMaxDist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in gui_eigenfaces_pButtonBdd.
function gui_eigenfaces_pButtonBdd_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_pButtonBdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    p = load('params.mat','Params');
    Params = p.Params;

    if isempty(get(handles.gui_eigenfaces_iTxtTrain,'string'))
        errordlg('Cal introduir el nombre d''imatges de cada personatge', 'Error', 'modal');
    else
        try    
            nTrainImgs = str2double(get(handles.gui_eigenfaces_iTxtTrain,'string'));
    
            if nTrainImgs < Params.nTrainImgs
                uiwait(msgbox(strcat('El nombre minim d''imatges d''entrenament ha de ser: ', num2str(Params.nTrainImgs)),'Error'));
            else       
                desactivaHandles([handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonLoad
                                    handles.gui_eigenfaces_pButtonEigen]);  

                path = uigetdir(Params.pathDatabase,'Selecciona path bdd');
                
                if path == 0
                    uiwait(msgbox('No s''ha seleccionat cap base de dades','Error'));    
                else
                    [w, noms] = MfaceRecognition.loadDatabasePca(true,nTrainImgs,path, Params.pathDatabaseMatFilePca);
                    uiwait(msgbox('Imatges d''entrenament carregades','Info'));                      
                end
                activaHandles([handles.gui_eigenfaces_pButtonBdd
                                        handles.gui_eigenfaces_pButtonBdd
                                        handles.gui_eigenfaces_pButtonLoad]);
            end
        catch err
            errordlg(getReport(err), 'Error', 'modal');
            activaHandles([handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonBdd
                                    handles.gui_eigenfaces_pButtonLoad
                                    handles.gui_eigenfaces_pButtonEigen]);
        end
    end


function gui_eigenfaces_iTxtTrain_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtTrain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_eigenfaces_iTxtTrain as text
%        str2double(get(hObject,'String')) returns contents of gui_eigenfaces_iTxtTrain as a double


% --- Executes during object creation, after setting all properties.
function gui_eigenfaces_iTxtTrain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtTrain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_eigenfaces_iTxtNumEigenvect_Callback(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtNumEigenvect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_eigenfaces_iTxtNumEigenvect as text
%        str2double(get(hObject,'String')) returns contents of gui_eigenfaces_iTxtNumEigenvect as a double


% --- Executes during object creation, after setting all properties.
function gui_eigenfaces_iTxtNumEigenvect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_eigenfaces_iTxtNumEigenvect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function desactivaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','off');
    end

% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function activaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','on');
    end
