function varargout = gui_fisherfaces(varargin)
% GUI_FISHERFACES M-file for gui_fisherfaces.fig
%      GUI_FISHERFACES, by itself, creates a new GUI_FISHERFACES or raises the existing
%      singleton*.
%
%      H = GUI_FISHERFACES returns the handle to a new GUI_FISHERFACES or the handle to
%      the existing singleton*.
%
%      GUI_FISHERFACES('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_FISHERFACES.M with the given input arguments.
%
%      GUI_FISHERFACES('Property','Value',...) creates a new GUI_FISHERFACES or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_fisherfaces_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_fisherfaces_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_fisherfaces

% Last Modified by GUIDE v2.5 08-Dec-2012 19:29:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_fisherfaces_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_fisherfaces_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_fisherfaces is made visible.
function gui_fisherfaces_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_fisherfaces (see VARARGIN)

% Choose default command line output for gui_fisherfaces
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

p = load('params.mat','Params');
Params = p.Params;

% Carreguem una imatge per defecte
Utils.doImage(handles.gui_fisherfaces_axesCara, Params.defaultImg);
Utils.doImage(handles.gui_fisherfaces_axesEigen, Params.defaultImg);

desactivaHandles(handles.gui_fisherfaces_pButtonFisher);
desactivaHandles(handles.gui_fisherfaces_pButtonLoad);
% UIWAIT makes gui_fisherfaces wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_fisherfaces_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in gui_fisherfaces_pButtonLoad.
function gui_fisherfaces_pButtonLoad_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_pButtonLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global rutaImatge;

p = load('params.mat','Params');
Params = p.Params;

% Quadre de dialeg per cercar una imatge
[file, path, index] = uigetfile(Params.filtreImg, 'Carrega una imatge');

% Es comprova que s'hagi seleccionat un fitxer
if ~isequal(file, 0)    
    rutaImatge = strcat(path, '\', file);
    Utils.doImage(handles.gui_fisherfaces_axesCara, rutaImatge); 
    activaHandles(handles.gui_fisherfaces_pButtonFisher);
else
    errordlg('No s''ha seleccionat cap fitxer','Error','modal');
end

% --- Executes on button press in gui_fisherfaces_pButtonFisher.
function gui_fisherfaces_pButtonFisher_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_pButtonFisher (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

 global rutaImatge;
 
 p = load('params.mat','Params');
 Params = p.Params;

    if isempty(get(handles.gui_fisherfaces_iTxtClass,'string'))
        errordlg('Cal introduir el parmetre nombre d''imatges per classes', 'Error', 'modal');        
    elseif isempty(get(handles.gui_fisherfaces_iTxtMaxDist,'string'))
        errordlg('Cal introduir una distancia entre imatges mxima', 'Error', 'modal');        
    elseif isempty(get(handles.gui_fisherfaces_iTxtNeigen,'string'))
        errordlg('Cal introduir un nombre d''eigenvectors', 'Error', 'modal');        
    else        
        Utils.doImage(handles.gui_fisherfaces_axesEigen, Params.imgProc);
        pause(3);
        try
            nPerClass = str2double(get(handles.gui_fisherfaces_iTxtClass,'string'));
            nEigen = str2double(get(handles.gui_fisherfaces_iTxtNeigen,'string'));        
            maxDist = str2double(get(handles.gui_fisherfaces_iTxtMaxDist,'string'));
            
            desactivaHandles([handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonLoad
                                    handles.gui_fisherfaces_pButtonFisher]);
            
            [w, noms] = MfaceRecognition.loadDatabaseLda(false,NaN,Params.pathDatabase, Params.pathDatabaseMatFileLda);
            iR = Utils.doGray(imread(rutaImatge));
            [idx, dist, imatge, errorMida] = MfaceRecognition.ldaFaceRecognition(iR,nEigen,nPerClass,w);
            
            
            activaHandles([handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonLoad
                                    handles.gui_fisherfaces_pButtonFisher]);
                        
            if errorMida
                errordlg('Error mida imatge de test', 'Error', 'modal');
                Utils.doImage(handles.gui_fisherfaces_axesCara, Params.defaultImg);
                Utils.doImage(handles.gui_fisherfaces_axesEigen, Params.defaultImg);
            else
                if dist <= maxDist
                    imshow(imatge,'Parent',handles.gui_fisherfaces_axesEigen);
                    
                    set(handles.gui_fisherfaces_iTxtDist,'string',num2str(dist));
                    set(handles.gui_fisherfaces_iTxtPersona,'string',noms(idx));
                else
                    Utils.doImage(handles.gui_fisherfaces_axesEigen, Params.imgNotRecognized);
                    set(handles.gui_fisherfaces_iTxtDist,'string',num2str(dist));
                end
            end
        catch err
             errordlg(getReport(err), 'Error', 'modal');
        end
    end


function gui_fisherfaces_iTxtDist_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_fisherfaces_iTxtDist as text
%        str2double(get(hObject,'String')) returns contents of gui_fisherfaces_iTxtDist as a double


% --- Executes during object creation, after setting all properties.
function gui_fisherfaces_iTxtDist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_fisherfaces_iTxtPersona_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtPersona (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_fisherfaces_iTxtPersona as text
%        str2double(get(hObject,'String')) returns contents of gui_fisherfaces_iTxtPersona as a double


% --- Executes during object creation, after setting all properties.
function gui_fisherfaces_iTxtPersona_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtPersona (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_fisherfaces_iTxtMaxDist_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_fisherfaces_iTxtMaxDist as text
%        str2double(get(hObject,'String')) returns contents of gui_fisherfaces_iTxtMaxDist as a double


% --- Executes during object creation, after setting all properties.
function gui_fisherfaces_iTxtMaxDist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtMaxDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in gui_fisherfaces_pButtonBdd.
function gui_fisherfaces_pButtonBdd_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_pButtonBdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    p = load('params.mat','Params');
    Params = p.Params;

 if isempty(get(handles.gui_fisherfaces_iTxtTrain,'string'))
        errordlg('Cal introduir el nombre d''imatges d''entrenament de cada personatge', 'Error', 'modal');
    else
        try    
            nTrainImgs = str2double(get(handles.gui_fisherfaces_iTxtTrain,'string'));
    
            if nTrainImgs < Params.nTrainImgs
                uiwait(msgbox(strcat('El nombre minim d''imatges d''entrenament ha de ser: ', num2str(Params.nTrainImgs)),'Error'));
            else
                desactivaHandles([handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonLoad
                                    handles.gui_fisherfaces_pButtonFisher]);
                                
                path = uigetdir(Params.pathDatabase,'Selecciona path bdd');
                
                if path == 0
                    uiwait(msgbox('No s''ha seleccionat cap base de dades','Error'));   
                else
                    [w, noms] = MfaceRecognition.loadDatabaseLda(true,nTrainImgs,path, Params.pathDatabaseMatFileLda);
                    uiwait(msgbox('Imatges d''entrenament carregades','Info'));
                end
                
                activaHandles([handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonBdd
                                    handles.gui_fisherfaces_pButtonLoad]);
            end
        catch err
            errordlg(getReport(err), 'Error', 'modal');
        end
    end

function gui_fisherfaces_iTxtTrain_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtTrain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_fisherfaces_iTxtTrain as text
%        str2double(get(hObject,'String')) returns contents of gui_fisherfaces_iTxtTrain as a double


% --- Executes during object creation, after setting all properties.
function gui_fisherfaces_iTxtTrain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtTrain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_fisherfaces_iTxtClass_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_fisherfaces_iTxtClass as text
%        str2double(get(hObject,'String')) returns contents of gui_fisherfaces_iTxtClass as a double


% --- Executes during object creation, after setting all properties.
function gui_fisherfaces_iTxtClass_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function desactivaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','off');
    end

% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function activaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','on');
    end



function gui_fisherfaces_iTxtNeigen_Callback(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtNeigen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_fisherfaces_iTxtNeigen as text
%        str2double(get(hObject,'String')) returns contents of gui_fisherfaces_iTxtNeigen as a double


% --- Executes during object creation, after setting all properties.
function gui_fisherfaces_iTxtNeigen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_fisherfaces_iTxtNeigen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
