function varargout = gui_params(varargin)
% GUI_PARAMS M-file for gui_params.fig
%      GUI_PARAMS, by itself, creates a new GUI_PARAMS or raises the existing
%      singleton*.
%
%      H = GUI_PARAMS returns the handle to a new GUI_PARAMS or the handle to
%      the existing singleton*.
%
%      GUI_PARAMS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_PARAMS.M with the given input arguments.
%
%      GUI_PARAMS('Property','Value',...) creates a new GUI_PARAMS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_params_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_params_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_params

% Last Modified by GUIDE v2.5 08-Dec-2012 04:19:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_params_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_params_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_params is made visible.
function gui_params_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_params (see VARARGIN)

% Choose default command line output for gui_params
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

actualDir = pwd;
rootFolder = uigetdir(strcat(actualDir,'\..'), 'Selecciona el directori arrel de l''aplicaci');

if rootFolder ~=0

    matFile = strcat(rootFolder,'\mat\params.mat');

    if exist(matFile,'file')
        p = load(matFile,'Params');
        Params = p.Params;

        set(handles.gui_params_iTxtRootDir, 'string', Params.rootDir);        
        set(handles.gui_params_iTxtNoDisp,'string',Params.defaultImg);
        set(handles.gui_params_iTxtProc,'string', Params.imgProc);
        set(handles.gui_params_iTxtNotFound,'string',Params.imgNotRecognized);
        set(handles.gui_params_iTxtFiltre,'string', Params.filtreImg);
        set(handles.gui_params_iTxtPathMatFiles,'string', Params.pathMatFiles);
        set(handles.gui_params_iTxtHaarFace,'string', Params.xmlHaarFace);
        set(handles.gui_params_iTxtHaarEye,'string', Params.xmlHaarEye);
        set(handles.gui_params_iTxtScaleFace,'string', Params.scaleFaceMin);
        set(handles.gui_params_iTxtScaleEye,'string',Params.scaleEyeMin);                    
        set(handles.gui_params_iTxtAmplada,'string',Params.amplada);
        set(handles.gui_params_iTxtAlcada,'string',Params.alcada);
        set(handles.gui_params_iTxtScale,'string',Params.scale);
        set(handles.gui_params_iTxtTrainImgs,'string',Params.nTrainImgs);
        %Params.pathDatabaseInsBdd = strcat(Params.rootDir,'\mat\candidates.mat');
        set(handles.gui_params_iTxtTrainBdd,'string',Params.pathDatabase);
        set(handles.gui_params_iTxtTestBdd,'string',Params.pathDatabaseTest);
        set(handles.gui_params_iTxtPcaMat,'string',Params.pathDatabaseMatFilePca);
        set(handles.gui_params_iTxtLdaMat,'string',Params.pathDatabaseMatFileLda);
        set(handles.gui_params_iTxtMatTest,'string',Params.pathDatabaseMatFileTest);
        set(handles.gui_params_iTxtCandidates,'string',Params.pathDatabaseInsBdd);
        set(handles.gui_params_iTxtPcaDist,'string',num2str(Params.pcaMaxDist));
        set(handles.gui_params_iTxtLdaDist,'string',num2str(Params.fisherMaxDist));
        set(handles.gui_params_iTxtEvects,'string',Params.nEigenVects);
        set(handles.gui_params_iTxtNclasses,'string',Params.numPerClass);
        set(handles.gui_params_iTxtPreview,'string',Params.preview);
        set(handles.gui_params_iTxtRecegvid,'string',Params.recEigenVid);
        set(handles.gui_params_iTxtRecegest,'string',Params.recEigenEst);
        set(handles.gui_params_iTxtVd,'string',Params.video);
        set(handles.gui_params_iTxtPh,'string',Params.photo);
        set(handles.gui_params_iTxtRecfishvid,'string',Params.recFisherVid);
        set(handles.gui_params_iTxtRecfishest,'string',Params.recFisherEst);   
    else
        uiwait(msgbox('No existeix la bdd de parmetres','Error'));
    end
else
    uiwait(msgbox('No s''ha seleccionat cap directori','Error'));
end


% UIWAIT makes gui_params wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_params_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function gui_params_iTxtRootDir_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRootDir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtRootDir as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtRootDir as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtRootDir_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRootDir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtPathMatFiles_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPathMatFiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtPathMatFiles as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtPathMatFiles as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtPathMatFiles_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPathMatFiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtTrainBdd_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtTrainBdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtTrainBdd as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtTrainBdd as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtTrainBdd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtTrainBdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtTestBdd_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtTestBdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtTestBdd as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtTestBdd as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtTestBdd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtTestBdd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function gui_params_iTxtPcaMat_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPcaMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtPcaMat as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtPcaMat as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtPcaMat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPcaMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtLdaMat_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtLdaMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtLdaMat as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtLdaMat as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtLdaMat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtLdaMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtMatTest_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtMatTest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtMatTest as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtMatTest as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtMatTest_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtMatTest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit12_Callback(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit12 as text
%        str2double(get(hObject,'String')) returns contents of edit12 as a double


% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtTrainImgs_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtTrainImgs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtTrainImgs as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtTrainImgs as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtTrainImgs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtTrainImgs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtPcaDist_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPcaDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtPcaDist as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtPcaDist as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtPcaDist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPcaDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtLdaDist_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtLdaDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtLdaDist as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtLdaDist as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtLdaDist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtLdaDist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtEvects_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtEvects (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtEvects as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtEvects as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtEvects_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtEvects (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtNclasses_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtNclasses (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtNclasses as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtNclasses as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtNclasses_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtNclasses (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtHaarFace_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtHaarFace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtHaarFace as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtHaarFace as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtHaarFace_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtHaarFace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtHaarEye_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtHaarEye (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtHaarEye as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtHaarEye as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtHaarEye_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtHaarEye (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtScaleEye_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtScaleEye (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtScaleEye as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtScaleEye as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtScaleEye_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtScaleEye (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtScaleFace_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtScaleFace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtScaleFace as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtScaleFace as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtScaleFace_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtScaleFace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtScale_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtScale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtScale as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtScale as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtScale_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtScale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtAlcada_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtAlcada (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtAlcada as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtAlcada as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtAlcada_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtAlcada (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtAmplada_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtAmplada (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtAmplada as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtAmplada as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtAmplada_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtAmplada (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function edit31_Callback(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit31 as text
%        str2double(get(hObject,'String')) returns contents of edit31 as a double


% --- Executes during object creation, after setting all properties.
function edit31_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtFiltre_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtFiltre (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtFiltre as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtFiltre as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtFiltre_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtFiltre (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtProc_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtProc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtProc as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtProc as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtProc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtProc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtNotFound_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtNotFound (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtNotFound as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtNotFound as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtNotFound_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtNotFound (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtNoDisp_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtNoDisp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtNoDisp as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtNoDisp as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtNoDisp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtNoDisp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtPreview_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPreview (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtPreview as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtPreview as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtPreview_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPreview (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtRecegvid_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecegvid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtRecegvid as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtRecegvid as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtRecegvid_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecegvid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtRecegest_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecegest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtRecegest as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtRecegest as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtRecegest_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecegest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtVd_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtVd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtVd as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtVd as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtVd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtVd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtPh_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtPh as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtPh as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtPh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtPh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtRecfishvid_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecfishvid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtRecfishvid as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtRecfishvid as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtRecfishvid_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecfishvid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gui_params_iTxtRecfishest_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecfishest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtRecfishest as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtRecfishest as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtRecfishest_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtRecfishest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in gui_params_pButtonSave.
function gui_params_pButtonSave_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_pButtonSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

rootDir = get(handles.gui_params_iTxtRootDir,'string');
matDir = get(handles.gui_params_iTxtPathMatFiles,'string');
matOpts = strcat(matDir,'\params.mat');

Params.rootDir = rootDir;        
Params.defaultImg = get(handles.gui_params_iTxtNoDisp,'string');
Params.imgProc = get(handles.gui_params_iTxtProc,'string');
Params.imgNotRecognized = get(handles.gui_params_iTxtNotFound,'string');
Params.filtreImg = get(handles.gui_params_iTxtFiltre,'string');
Params.pathMatFiles = get(handles.gui_params_iTxtPathMatFiles,'string');
Params.xmlHaarFace =  get(handles.gui_params_iTxtHaarFace,'string');
Params.xmlHaarEye =  get(handles.gui_params_iTxtHaarEye,'string');
Params.scaleFaceMin = str2double(get(handles.gui_params_iTxtScaleFace,'string'));
Params.scaleEyeMin = str2double(get(handles.gui_params_iTxtScaleEye,'string'));                    
Params.amplada = str2double(get(handles.gui_params_iTxtAmplada,'string'));
Params.alcada = str2double(get(handles.gui_params_iTxtAlcada,'string'));
Params.scale = str2double(get(handles.gui_params_iTxtScale,'string'));
Params.nTrainImgs = str2double(get(handles.gui_params_iTxtTrainImgs,'string'));
%Params.pathDatabaseInsBdd = strcat(Params.rootDir,'\mat\candidates.mat');
Params.pathDatabase = get(handles.gui_params_iTxtTrainBdd,'string');
Params.pathDatabaseTest = get(handles.gui_params_iTxtTestBdd,'string');
Params.pathDatabaseMatFilePca = get(handles.gui_params_iTxtPcaMat,'string');
Params.pathDatabaseMatFileLda = get(handles.gui_params_iTxtLdaMat,'string');
Params.pathDatabaseMatFileTest = get(handles.gui_params_iTxtMatTest,'string');
Params.pathDatabaseInsBdd = get(handles.gui_params_iTxtCandidates,'string');
Params.pcaMaxDist = str2double(get(handles.gui_params_iTxtPcaDist,'string'));
Params.fisherMaxDist = str2double(get(handles.gui_params_iTxtLdaDist,'string'));
Params.nEigenVects = str2double(get(handles.gui_params_iTxtEvects,'string'));
Params.numPerClass = str2double(get(handles.gui_params_iTxtNclasses,'string'));
Params.preview = get(handles.gui_params_iTxtPreview,'string');
Params.recEigenVid = get(handles.gui_params_iTxtRecegvid,'string');
Params.recEigenEst = get(handles.gui_params_iTxtRecegest,'string');
Params.video = get(handles.gui_params_iTxtVd,'string');
Params.photo = get(handles.gui_params_iTxtPh,'string');
Params.recFisherVid = get(handles.gui_params_iTxtRecfishvid,'string');
Params.recFisherEst = get(handles.gui_params_iTxtRecfishest,'string');   

save(matOpts,'Params');

uiwait(msgbox('Dades guardades'));


function gui_params_iTxtCandidates_Callback(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtCandidates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gui_params_iTxtCandidates as text
%        str2double(get(hObject,'String')) returns contents of gui_params_iTxtCandidates as a double


% --- Executes during object creation, after setting all properties.
function gui_params_iTxtCandidates_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gui_params_iTxtCandidates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
