function varargout = gui_system(varargin)
% GUI_SYSTEM M-file for gui_system.fig
%      GUI_SYSTEM, by itself, creates a new GUI_SYSTEM or raises the existing
%      singleton*.
%
%      H = GUI_SYSTEM returns the handle to a new GUI_SYSTEM or the handle to
%      the existing singleton*.
%
%      GUI_SYSTEM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_SYSTEM.M with the given input arguments.
%
%      GUI_SYSTEM('Property','Value',...) creates a new GUI_SYSTEM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_system_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_system_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_system

% Last Modified by GUIDE v2.5 23-Nov-2012 00:00:11

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_system_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_system_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_system is made visible.
function gui_system_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_system (see VARARGIN)

% Choose default command line output for gui_system
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

 p = load('params.mat','Params');
 Params = p.Params;
    
% Set default background img
Utils.doImage(handles.gui_system_axesPreview, Params.defaultImg);

% Load webcam object
clear global cam;
global cam;

cam = Mcam();

% UIWAIT makes gui_system wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_system_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in gui_system_pButtonStart.
function gui_system_pButtonStart_Callback(hObject, eventdata, handles)
% hObject    handle to gui_system_pButtonStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global cam;
 p = load('params.mat','Params');
    Params = p.Params;
    
try
    % Origen webcam
    if get(handles.gui_system_rButtonW,'value')==1     
        set(handles.gui_system_pButtonStop,'enable','on');
        
        if not(cam.iniWebCam())
            errordlg('No es pot inicialitzar la webcam');
        else
            set(handles.gui_system_txtInfo,'String','Fent reconeixement...');
            cam.realVideo(handles.gui_system_axesPreview,Params.recEigenVid);
            cam.startWebCamCapture();
        end	
    % Origen imatge estàtica    
    else
        set(handles.gui_system_pButtonStop,'enable','off');
                
        [file, path, index] = uigetfile(Params.filtreImg, 'Selecciona una imatge', Params.rootDir);

        if ~isequal(file, 0)    
            rutaImatge = strcat(path, '\', file);
            Utils.doImage(handles.gui_system_axesPreview, rutaImatge); 
            
            set(handles.gui_system_txtInfo,'String','Fent reconeixement...');
            desactivaHandles([handles.gui_system_pButtonStart]);
            pause(2);
            cam.realVideo(handles.gui_system_axesPreview,Params.recEigenEst);
            activaHandles([handles.gui_system_pButtonStart]);
        else
            errordlg('Fitxer incorrecte','Error','modal');
            Utils.doImage(handles.gui_system_axesPreview, Params.defaultImg);
        end
    end
catch err 
    errordlg(getReport(err), 'Error', 'modal'); 
    Utils.doImage(handles.gui_system_axesPreview, Params.defaultImg);
end

set(handles.gui_system_txtInfo,'String','');

% --- Executes on button press in gui_system_pButtonStop.
function gui_system_pButtonStop_Callback(hObject, eventdata, handles)
% hObject    handle to gui_system_pButtonStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global cam;
 p = load('params.mat','Params');
    Params = p.Params;
    
try
    % Si l'origen és webcam cal aturar el timer i la webcam
    if get(handles.gui_system_rButtonW,'value')==1   
        cam.stopTimer();
        cam.stopWebCamCapture();
    end
catch err 
    errordlg(getReport(err), 'Error', 'modal'); 
    Utils.doImage(handles.gui_system_axesPreview, Params.defaultImg);
end

% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function desactivaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','off');
    end

% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function activaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','on');
    end