function varargout = gui_systemlda(varargin)
% GUI_SYSTEMLDA M-file for gui_systemlda.fig
%      GUI_SYSTEMLDA, by itself, creates a new GUI_SYSTEMLDA or raises the existing
%      singleton*.
%
%      H = GUI_SYSTEMLDA returns the handle to a new GUI_SYSTEMLDA or the handle to
%      the existing singleton*.
%
%      GUI_SYSTEMLDA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_SYSTEMLDA.M with the given input arguments.
%
%      GUI_SYSTEMLDA('Property','Value',...) creates a new GUI_SYSTEMLDA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_systemlda_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_systemlda_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui_systemlda

% Last Modified by GUIDE v2.5 02-Dec-2012 22:43:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_systemlda_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_systemlda_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_systemlda is made visible.
function gui_systemlda_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_systemlda (see VARARGIN)

% Choose default command line output for gui_systemlda
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

 p = load('params.mat','Params');
    Params = p.Params;

% Set default background img
Utils.doImage(handles.gui_systemlda_axesPreview, Params.defaultImg);

% Load webcam object
clear global cam;
global cam;

cam = Mcam();

% UIWAIT makes gui_systemlda wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_systemlda_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in gui_systemlda_pButtonStart.
function gui_systemlda_pButtonStart_Callback(hObject, eventdata, handles)
% hObject    handle to gui_systemlda_pButtonStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global cam;
 p = load('params.mat','Params');
    Params = p.Params;
    
try
    % Origen webcam
    if get(handles.gui_systemlda_rButtonW,'value')==1     
        set(handles.gui_systemlda_pButtonStop,'enable','on');
        
        if not(cam.iniWebCam())
            errordlg('No es pot inicialitzar la webcam');
        else
            set(handles.gui_systemlda_txtInfo,'String','Fent reconeixement...');
            cam.realVideo(handles.gui_systemlda_axesPreview,Params.recFisherVid);
            cam.startWebCamCapture();
        end	
    % Origen imatge estàtica    
    else
        set(handles.gui_systemlda_pButtonStop,'enable','off');
                
        [file, path, index] = uigetfile(Params.filtreImg, 'Selecciona una imatge', Params.rootDir);

        if ~isequal(file, 0)    
            rutaImatge = strcat(path, '\', file);
            Utils.doImage(handles.gui_systemlda_axesPreview, rutaImatge); 
            
            set(handles.gui_systemlda_txtInfo,'String','Fent reconeixement...');
            desactivaHandles([handles.gui_systemlda_pButtonStart]);
            pause(2);
            cam.realVideo(handles.gui_systemlda_axesPreview,Params.recFisherEst);
            activaHandles([handles.gui_systemlda_pButtonStart]);
        else
            errordlg('Fitxer incorrecte','Error','modal');
            Utils.doImage(handles.gui_systemlda_axesPreview, Params.defaultImg);
        end
    end
catch err 
    errordlg(getReport(err), 'Error', 'modal'); 
    Utils.doImage(handles.gui_systemlda_axesPreview, Params.defaultImg);
end

set(handles.gui_systemlda_txtInfo,'String','stop');


% --- Executes on button press in gui_systemlda_pButtonStop.
function gui_systemlda_pButtonStop_Callback(hObject, eventdata, handles)
% hObject    handle to gui_systemlda_pButtonStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global cam;
 p = load('params.mat','Params');
    Params = p.Params;
    
try
    % Si l'origen és webcam cal aturar el timer i la webcam
    if get(handles.gui_systemlda_rButtonW,'value')==1   
        cam.stopTimer();
        cam.stopWebCamCapture();
    end
catch err 
    errordlg(getReport(err), 'Error', 'modal'); 
    Utils.doImage(handles.gui_systemlda_axesPreview, Params.defaultImg);    
end


% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function desactivaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','off');
    end

% -----------------------------------------------------------------
% Input params:
% newMat
% maxImgs
% databasePath  
% databasePathMat
%
% Output params:
% w
% noms        
% -----------------------------------------------------------------

function activaHandles(arrHandles)
    
    for i=1:size(arrHandles,1)
        set(arrHandles(i),'enable','on');
    end
